/** Derivative Checker
 *
 *  \file   derivativeChecker.h
 *  \author Benedict Geihe
 *  \date   01.01.2013
 *
 */


#ifndef __DERIVATIVCHECKER_H
#define __DERIVATIVCHECKER_H

#include "../vecmat/operator.h"

//! Derivative Checker
class DerivativeChecker
{
    public:
        DerivativeChecker(const Operator<Vector,double> & energy, const Operator<Vector,Vector> & gradient);

        void check    ( const unsigned int dof, const Vector & point, string filename = "derivative" );
        void checkAll ( const Vector & point, string filename = "derivative" );

    protected:
        const Operator<Vector,double> & _energy;
        const Operator<Vector,Vector> & _gradient;

        const double _delta;
        const int    _samples;
};

#endif
