/** Standard Bilinearformen
 *
 *  \file   bilf.h
 *  \author Benedict Geihe, Behrend Heeren
 *  \date   16.10.2012
 *
 */

#ifndef __BILF_H
#define __BILF_H

#include "quadrature.h"
#include "../triang/grid.h"
#include "../vecmat/tensor.h"


/*************************************************************************************************/
/*  Bilinearformen auf Dreiecken                                                                 */
/*************************************************************************************************/
//! Bilinearform zum Aufstellen der Massematrix
class MassBilf
{
    public:
        double operator() (const Triangle & t, const BarCoord & q, int i, int j ) const;
};

//! Bilinearform zum Aufstellen der Steifigkeitsmatrix
class StiffBilf
{
    public:
        double operator() (const Triangle & t, const BarCoord & q, int i, int j ) const;
};




#endif
