/** Bilinearformen fuer Diffusionsprobleme
 *
 *  \file   diffusiveBilf.cpp
 *  \author Benedict Geihe
 *  \date   19.04.2009
 *
 */

#include "diffusiveBilf.h"

//! Constructor, just point to argument
IsoDiffusiveStiffBilf::IsoDiffusiveStiffBilf( TensorOrder0 & tensor )
    : _tensor( &tensor )
{ }

//! Deep Copy Constructor
IsoDiffusiveStiffBilf::IsoDiffusiveStiffBilf( const IsoDiffusiveStiffBilf & other )
    : _tensor ( other._tensor->clone() )
{ }

//! Get reference to stored tensor to allow modification
TensorOrder0 * IsoDiffusiveStiffBilf::getTensorPtr()
{
    return _tensor;
}

//! Wertet \f$ a(x) \nabla \varphi_i(x) \nabla \varphi_j(x) \f$ auf einem Dreieck aus
double IsoDiffusiveStiffBilf::operator() (const Triangle & t, const BarCoord & q, int i, int j ) const
{
  return StiffBilf::operator()( t, q, i, j ) * _tensor->evaluate( t, q );
}
