/** Bilinearformen fuer Diffusionsprobleme
 *
 *  \file   diffusiveBilf.h
 *  \author Benedict Geihe, Behrend Heeren
 *  \date   16.10.2012
 *
 */

#ifndef __DIFFUSIVEBILF_H
#define __DIFFUSIVEBILF_H

#include "bilf.h"
#include "../vecmat/tensor.h"


//! Bilinearform zum Aufstellen einer gewichteten Steifigkeitsmatrix
class IsoDiffusiveStiffBilf : public StiffBilf
{
    public:
        IsoDiffusiveStiffBilf( TensorOrder0 & tensor );
        IsoDiffusiveStiffBilf( const IsoDiffusiveStiffBilf & other );

        TensorOrder0 * getTensorPtr();

        double operator() (const Triangle & t, const BarCoord & q, int i, int j) const;

    protected:
        TensorOrder0 * _tensor;

    private:
        // prevent implicit implementation, seems to have to been used by some stl vector methods
        IsoDiffusiveStiffBilf & operator=(const IsoDiffusiveStiffBilf & other);
};

#endif
