/** Bilinear forms for elasticity problems
 *
 *  \file   elastBilf.h
 *  \author Benedict Geihe, Behrend Heeren
 *  \date   15.12.2012
 *
 */

#ifndef __ELASTBILF_H
#define __ELASTBILF_H

#include "../triang/grid.h"
#include "quadrature.h"


//! Bilinear form for elasticity stiffness matrix
class PhasefieldElastStiffBilf
{
    public:
        PhasefieldElastStiffBilf ( const Vector & pf, const double lambda = 1, const double mu = 1, const double weak = 1e-2 );
        double operator() (const Triangle & t, const BarCoord & q, int i, int j, int k, int l ) const;

    private:
        const Vector & _pf;
        const double _lambda_strong;
        const double _lambda_weak;
        const double _mu_strong;
        const double _mu_weak;
};

#endif
