/** Quadraturregeln fuer das Programmierpraktikum
 *
 *  \file   quadrature.cpp
 *  \author Stefan W. von Deylen, Benedict Geihe
 *  \date   01.10.2008
 *
 */

#include "quadrature.h"

//! Konstruktor
BarCoord::BarCoord( double bc1, double bc2, double bc3 )
{
    (*this)[0] = bc1;
    (*this)[1] = bc2;
    (*this)[2] = bc3;
}

BarCoord1D::BarCoord1D( double bc1, double bc2 )
{
    (*this)[0] = bc1;
    (*this)[1] = bc2;
}

// Statische Initialisierungen
const int       BarQuad1::_numPoints   = 1;
const double    BarQuad1::_weight[1]   = { 1. };
const BarCoord  BarQuad1::_barCoord[1] = { BarCoord(1.0/3.0, 1.0/3.0, 1.0/3.0) };

const int       BarQuad2::_numPoints   = 3;
const double    BarQuad2::_weight[3]   = { 1.0/3.0, 1.0/3.0, 1.0/3.0 };
const BarCoord  BarQuad2::_barCoord[3] = { BarCoord( 0.5, 0.5, 0.0 ),
                                           BarCoord( 0.0, 0.5, 0.5 ),
                                           BarCoord( 0.5, 0.0, 0.5 )  };

const int       BarQuad3::_numPoints   = 7;
const double    BarQuad3::_weight[7]   = { 1.0/20.0, 1.0/20.0, 1.0/20.0, 2.0/15.0, 2.0/15.0, 2.0/15.0, 27.0/60.0 };
const BarCoord  BarQuad3::_barCoord[7] = { BarCoord( 1.0, 0.0, 0.0 ),
                                           BarCoord( 0.0, 1.0, 0.0 ),
                                           BarCoord( 0.0, 0.0, 1.0 ),
                                           BarCoord( 0.5, 0.5, 0.0 ),
                                           BarCoord( 0.0, 0.5, 0.5 ),
                                           BarCoord( 0.5, 0.0, 0.5 ),
                                           BarCoord( 1.0/3.0, 1.0/3.0, 1.0/3.0 )  };

const int         LineQuad1::_numPoints   = 1;
const double      LineQuad1::_weight[1]   = { 1. };
const BarCoord1D  LineQuad1::_barCoord[1] = { BarCoord1D(1.0/2.0, 1.0/2.0) };