/** Quadraturregeln fuer das Programmierpraktikum
 *
 *  \file   quadrature.h
 *  \author Stefan W. von Deylen, Benedict Geihe
 *  \date   01.10.2008
 *
 */

#ifndef __QUADRATURE_H
#define __QUADRATURE_H

#include "../triang/smallVector.h"

//! Klasse fuer baryzentrische Koordinaten
class BarCoord: public SmallVector<3 ,double>
{
    public:
        BarCoord( double bc1, double bc2, double bc3 );
};

class BarCoord1D : public SmallVector<2 ,double>
{
    public:
        BarCoord1D( double bc1, double bc2 );
};

//! Quadraturregel: Ordnung 1
class BarQuad1
{
    public:
        static const int       _numPoints;
        static const double    _weight[1];
        static const BarCoord  _barCoord[1];
};

//! Quadraturregel: Ordnung 2
class BarQuad2
{
    public:
        static const int       _numPoints;
        static const double    _weight[3];
        static const BarCoord  _barCoord[3];
};

//! Quadraturregel: Ordnung 3
class BarQuad3
{
    public:
        static const int       _numPoints;
        static const double    _weight[7];
        static const BarCoord  _barCoord[7];
};

//! Quadraturregel: Ordnung 1
class LineQuad1
{
    public:
        static const int         _numPoints;
        static const double      _weight[1];
        static const BarCoord1D  _barCoord[1];
};

#endif
