/** Klasse fuer die Knoten einer Triangulierung
 *
 *  \file   node.cpp
 *  \author Stefan W. von Deylen, Benedict Geihe
 *  \date   18.09.2008
 *
 */

#include "node.h"

//! Kostruktor aus einem grid
template <typename NodeType, typename GridType>
NodeIteratorTemplate< NodeType, GridType >::NodeIteratorTemplate(GridType & grid)
    : _grid(grid)
    , _currentIndex(0)
{
}
// ------------------------------------------------------------------------------------------------

//! Iterator am Ende der Knotenliste?
template <typename NodeType, typename GridType>
bool NodeIteratorTemplate< NodeType, GridType >::notAtEnd()
{
    return ( _currentIndex < _grid._nodeList.size() );
}
// ------------------------------------------------------------------------------------------------

//! Inkrement-Operator
template <typename NodeType, typename GridType>
NodeIteratorTemplate< NodeType, GridType > & NodeIteratorTemplate< NodeType, GridType >::operator++()
{
    _currentIndex++;
    return *this;
}
// ------------------------------------------------------------------------------------------------

//! Dekrement-Operator
template <typename NodeType, typename GridType>
NodeIteratorTemplate< NodeType, GridType > & NodeIteratorTemplate< NodeType, GridType >::operator--()
{
    _currentIndex--;
    return *this;
}
// ------------------------------------------------------------------------------------------------

//! Dereferenzierung: Zugriff auf Node
template <typename NodeType, typename GridType>
NodeType & NodeIteratorTemplate< NodeType, GridType >::operator*()
{
    return _grid._nodeList[_currentIndex];
}
// ------------------------------------------------------------------------------------------------

//! Dereferenzierung: Zugriff auf member von Node
template <typename NodeType, typename GridType>
NodeType * NodeIteratorTemplate< NodeType, GridType >::operator->()
{
    return &(_grid._nodeList[_currentIndex]);
}
// ------------------------------------------------------------------------------------------------

//! Liefert globalen Index des aktuellen Knotens
template <typename NodeType, typename GridType>
GlobalIndex NodeIteratorTemplate< NodeType, GridType >::getIndex() const
{
    return _currentIndex;
}
// ------------------------------------------------------------------------------------------------


// Explizite Instanzierung der verwendeten Iteratoren
template class NodeIteratorTemplate<Node, Grid>;
template class NodeIteratorTemplate<const Node, const Grid>;
