/** Klasse fuer die Knoten einer Triangulierung
 *
 *  \file   node.h
 *  \author Stefan W. von Deylen, Benedict Geihe
 *  \date   18.09.2008
 *
 */

#ifndef __node_h
#define __node_h

#include <vector>

#include "smallVector.h"

using namespace std;

//! Knoten-"Klasse": Vektor mit x- und y-Koordinate
typedef SmallVector2<> Node;
typedef vector<Node> NodeList;
template <typename NodeType, typename GridType> class NodeIteratorTemplate;

// globale und lokale Indices sind integer
typedef int GlobalIndex;
typedef int LocalIndex;

// Wert fuer nicht gesetzten Index ist -1
const int IndexNotSet = -1;

#include "grid.h"

// ----------------------------------------------------------------------------------------------------------------------


//! Iterator ueber alle Knoten
//! (Template fuer die const und nicht-const Variante)
template <typename NodeType, typename GridType>
class NodeIteratorTemplate
{
    public:
        NodeIteratorTemplate(GridType & grid);

        bool notAtEnd();
        NodeIteratorTemplate & operator++();
        NodeIteratorTemplate & operator--();

        NodeType & operator*();
        NodeType * operator->();

        GlobalIndex getIndex() const;

    protected:
        GridType & _grid;
        size_t _currentIndex;
};

#endif
