#include <iostream>

using namespace std;

#include "matrix.h"
#include "vector.h"

int main()
{
    // Standard Konstruktor
    Vector v0;
    cout << endl << "Vektor der Laenge 0: " << v0;

    // Vektor der Laenge 23
    Vector v1 ( 11 );
    v1.setZero();

    Vector v2 ( 11 );
    for ( int i = 0; i < 11; i++ )
    {
        v2[i] = double(i-5)/3.0;
    }

    // Kopierkonstruktor
    Vector v3 ( v2 );

    v1.setToMultiple( 3.0, v2 );
    cout << "v1: " << v1;

    v2.addMultiple( 2.0, v2);
    cout << "v2: " << v2 << endl;

    v3 *= 3.0;

    cout << "v1 * v2    = " << v1 * v2 << endl;
    cout << "||v3||_2^2 = " << v3.norm_l2q() << endl;
    cout << "max (v2)   = " << v2.norm_linf() << endl;
    cout << "v1 == v2 ?   " << ( ( v1 == v2 ) ? "JA!" : "NEIN!" ) << endl;
    v1 = v0;
    cout << "v1 == v2 ?   " << ( ( v1 == v2 ) ? "JA!" : "NEIN!" ) << endl << endl;


    Matrix m_zeroLength;
    cout << "Matrix ohne Eintraege: " << m_zeroLength;

    Matrix m1( 2, 2 );
    m1 (0,0) = 1.0;  m1 (0,1) = 2.0;
    m1 (1,0) = 2.0;  m1 (1,1) = 3.0;

    Matrix m2( m1 );

    Matrix m3 ( 2, 2);
    m3.mmult( m1, m2 );

    cout << "m2: " << m2;
    cout << "m3: " << m3;

    cout << "||m2||_1   = " << m2.norm_l1() << endl;
    cout << "||m2||_inf = " << m2.norm_linf() << endl << endl;

    cout << "*** Das war's! ***" << endl << endl;


#if defined(__MINGW32_VERSION) || defined(_MSC_VER)  || defined(__BCPLUSPLUS__)
    system("PAUSE");
#endif
}
